-- 天下闻名
Lua_TQiYuanPanel = class("Lua_TQiYuanPanel",Lua_DisplayObject)
function Lua_TQiYuanPanel:ctor(p)	
	self:superCall("ctor", p);
end

function Lua_TQiYuanPanel:buildShowItem(go)
	self.qyTaskList = Lua_DragList.new(self.content,1, Vector4(0, 0, 700, 390));
	self.qyTaskList:setListCell(Lua_TQiyuanItem, 130, 700, 1);
	self.qyTaskList:setLocation(204, -31, 0);

	self:addLuaEvent("GETONEINFO_UPDATA", self, self.qiyuanitemUpdata);
end

function Lua_TQiYuanPanel:qiyuanitemUpdata()
	local qiyuanData = DataCenter.qiyuanData;
	local len = qiyuanData.qyTaskArr:getSize();
	local val = 0;
	local redDotVal = 0;
	for i = 1, len do
		if qiyuanData.qyTaskArr[i].flag == 2 then
			val = val + 1;
		elseif qiyuanData.qyTaskArr[i].flag == 1 then
			redDotVal = 1;
		end
	end
	Lua_MsgUtil.callFunc("QIYUAN_VALUPDATA", {count = len, val = val,
		redDotVal = redDotVal, activeskill = qiyuanData.activeskill});

	self.qyTaskList:setLuaArrayData(qiyuanData.qyTaskArr, false);
end

function Lua_TQiYuanPanel:dispose()
	if self.qyTaskList ~= nil then
		self.qyTaskList:dispose();
		self.qyTaskList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_TQiyuanItem = class("Lua_TQiyuanItem", Lua_ListCell);
function Lua_TQiyuanItem:ctor(p)
	self:superCall("ctor", p, "Lua_QiYuanpanel_skin");
end

function Lua_TQiyuanItem:buildShowItem()
	self:superCall("buildShowItem");

    self.tips:setEnable(false);

	self.arr = Array();
	self.arr1 = Array();
	self.arr2 = Array();
	self.arr3 = Array();

	self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 236, 7, 0, 0);
	self.redDot.name = "redDot";
	self.redDot:setDepth(3);
end

function Lua_TQiyuanItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local len = #data.goodsid;
	local num = self.arr:getSize() - len;
	local len1 = #data.bossid;
	local itemImg, label, iconmeel, itemImgbg;
	while (num > 0) do
		itemImg = self.arr:shift();
		itemImg:dispose();

		iconmeel = self.arr1:shift();
		iconmeel:dispose();

		label = self.arr2:shift();
		label:dispose();

		itembg = self.arr3:shift()
		itembg:dispose();

		num = num - 1;
	end

	while (num < 0) do
		itemImg = UICreate.createImage(self.content, "", 100, 80, -120, -20);
		itemImg:setDepth(5);
		itemImg:setScale(0.9, 0.9, 0.9);
		self.arr:add(itemImg);

		iconmeel = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_bq_001", -120, -40, 74, 60);
		iconmeel:setDepth(6);
		iconmeel:setEnable(false);
		self.arr1:add(iconmeel);

		label = UICreate.createLabel(self.content, "", -144, -38, 100, 30, 16);
		label.depth = 7;
		label.effectStyle = 3;
		label.effectColorStr = Lua_ColorDefine.transColor("000000");
		label:setEffectDistance(2, 2);
		self.arr2:add(label);

		itembg = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_txk_01", -120, -20, 80, 80);
		itembg:setDepth(4);
		self.arr3:add(itembg);

		num = num + 1;
	end

	local confg;
	for i = 1, len do
		confg = getConfig({"monster", data.goodsid[i]});
		self.setUrl = "/images/head/boss/"..confg.head_src ..".png";

		itemImg = self.arr[i];
		itemImg.name = tonumber(i);
		itemImg:setUrl(self.setUrl);
		itemImg:SetDimensions(74, 74);
		itemImg:setLocation(-213 + (i - 1) * 100, -13, 0);
		itemImg:addClickFuntion(self,self.ontipsClick);

		itembg = self.arr3[i];
		itembg:setLocation(-213 + (i - 1) * 100, -13, 0);

		self.arr[i].color = Color.New(1, 1, 1, 1);
		self.arr1[i]:setEnable(false);
		self.arr1[i]:setLocation(-213 + (i - 1) * 100, -13, 0);
		self.arr2[i].text = "";
		self.arr2[i]:setLocation(-237 + (i - 1) * 100, -13, 0);
		for j = 1, len1 do
			if data.bossid[j] == data.goodsid[i] then
				self.arr[i].color = Color.New(0, 1, 1, 1);
				self.arr1[i]:setEnable(true);
				self.arr2[i].text = LanUtil.getValue(122317);
				break;
			end
		end
	end

	self.tipsLabel.text = data.name;

	if data.numreward == 1 then
		self.money:setAltas("icon_atlas_3", "money_209000001");
	elseif data.numreward == 2 then
		self.money:setAltas("icon_atlas_3", "money_209000002");
	elseif data.numreward == 3 then
		self.money:setAltas("icon_atlas_3", "money_209000003");
	end

	if data.flag ==  0 then -- 未达成
		self.btn.label = LanUtil.getValue(122310);
		self.btn:removeClickFuntion(self, self.onbtnClick);
		self.btn:addClickFuntion(self, self.ongoClick);

		self.btn:setEnable(true);
		self.redDot:setEnable(false);
		self.getBg:setEnable(false);

		self.countLabel.text = string.format("[ebddcc]%s（[ff1d2a]%s[-]/%s[-]）",
			tostring(data.reward), tostring(len1), tostring(len));
	elseif data.flag == 1 then -- 可领取
		self.btn.label = LanUtil.getValue(120813);
		self.btn:removeClickFuntion(self, self.ongoClick);
		self.btn:addClickFuntion(self, self.onbtnClick);

		self.btn:setEnable(true);
		self.redDot:setEnable(true);
		self.getBg:setEnable(false);

		self.countLabel.text = string.format("%s%s", tostring(data.reward), LanUtil.getValue(122318));
	else -- 已领取
		self.btn:setEnable(false);
		self.redDot:setEnable(false);
		self.getBg:setEnable(true);

		self.countLabel.text = string.format("%s%s", tostring(data.reward), LanUtil.getValue(122318));
	end
	self.money:setLocation(self.tipsLabel.mainContent.transform.localPosition.x + self.tipsLabel.width + 20, 39, 0);
	self.countLabel:setLocation(self.money.mainContent.transform.localPosition.x + 20, 39, 0)
end

function Lua_TQiyuanItem:onbtnClick(go)
	DataCenter.qiyuanData:getReward(self._data.chapter)
end

function Lua_TQiyuanItem:ontipsClick(go)
	local confg = getConfig({"monster", tonumber(self._data.goodsid[tonumber(go.name)])});
	local secen = getConfig({"scene", tonumber(self._data.bossScene[tonumber(go.name)]), "name"});
	Lua_WindowUtil.openWin("Lua_BossTipsWindow", nil, {name = confg.name, lvl = confg.lvl,
		scenename = secen, iconUrl = "/images/head/boss/" .. confg.head_src .. ".png"});
end

function Lua_TQiyuanItem:ongoClick(go)
	if self._data.index == 5 then
		local cfg = getConfig({"func_open", 10048});
		if cfg ~= nil and DataCenter.roleData.level >= cfg.cond_level then
			Lua_WindowUtil.openWin("Lua_BossMainWindow", nil, 4);
			Lua_WindowUtil.openWin("Lua_QiYuanWindow", WinParam.ACTION_CLOSE);
		else
			OperateAlert.show(LanUtil.getValue(34))
		end
	else
		local cfg = getConfig({"func_open", 10045});
		if cfg ~= nil and DataCenter.roleData.level >= cfg.cond_level then
			Lua_WindowUtil.openWin("Lua_BossMainWindow", nil, 1);
			Lua_WindowUtil.openWin("Lua_QiYuanWindow", WinParam.ACTION_CLOSE);
		else
			OperateAlert.show(LanUtil.getValue(34))
		end
	end
end